---
format: Org
categories: emacs config apps
toc: yes
title: csb-apps
content:
...

* Table of Contents                                 :TOC:noexport:
:PROPERTIES:
:VISIBILITY: all
:END:

- [[#introduction][Introduction]]
- [[#header][Header]]
- [[#generic][Generic]]
- [[#web-applications][Web Applications]]
  - [[#twittering][Twittering]]
    - [[#helper][Helper]]
    - [[#keys][Keys]]
    - [[#variables][Variables]]
    - [[#hooks][Hooks]]
  - [[#readability][Readability]]
  - [[#pinboard][Pinboard]]
    - [[#helper-defuns][helper defuns]]
    - [[#variables-1][Variables]]
    - [[#keys-1][Keys]]
  - [[#reddit][Reddit]]
  - [[#diaspora][Diaspora]]
  - [[#lobsters][Lobsters]]
- [[#stack-exchange][Stack Exchange]]
- [[#deft][Deft]]
- [[#proced][Proced]]
- [[#paradox][Paradox]]
- [[#calendar][Calendar]]
- [[#origami][Origami]]
- [[#erc][Erc]]
- [[#bitlbee][Bitlbee]]
- [[#telegram][Telegram]]
- [[#eww][EWW]]
- [[#deft-1][Deft]]
- [[#sx][SX]]
- [[#trailer][Trailer]]

* Introduction

* Header

#+begin_src emacs-lisp
  ;; package --- Summary
  ;;
  ;;; Commentary:
  ;;
  ;; This file contains ...
  ;;
  ;;; Code:
#+end_src

* Generic

#+begin_src emacs-lisp
  (eval-when-compile
    (require 'cl-lib)
    (require 'csb-miscellaneous))
#+end_src

#+begin_src emacs-lisp
  (define-key launcher-map "c" #'calc)
  (define-key launcher-map "F" #'find-dired)
  ;; (define-key launcher-map "h" #'man) ; Help
  ;; (define-key launcher-map "i" #'package-install-from-buffer)
  ;; (define-key launcher-map "n" #'nethack)
  ;; (define-key launcher-map "i" #'my-irc)
#+end_src

* EWW

#+begin_src emacs-lisp
  (use-package eww
    :preface
    (csb/require 'csb-www t)
    :config
    (csb/org-require 'csb-www t))
#+end_src

* Guix

#+begin_src emacs-lisp
  (use-package guix
    :commands (guix)
    :config
    ;; Under emacs, I’m using a dedicated profile
    (setq guix-current-profile (getenv "GUIX_PROFILE"))
    :bind (:map launcher-map
                ("g" . guix)))
#+end_src

_Environment_

Check guile is present under =$GUIX_PROFILE=

#+begin_src emacs-lisp :tangle no
  (getenv "GUIX_PROFILE")
  (executable-find "guile")
#+end_src

Note that, in order for emacs to detect an env variable, it must be exported from the shell.

* Mu4e / Mail

Main enter function to open a mu4e perspective.

#+begin_src emacs-lisp
  (use-package mu4e

    :preface (csb/require 'csb-mu4e)

    :commands (mu4e)

    :init

    (defun csb/mu4e ()
      (interactive)
      (cond ((csb/sb-check-open)
             ;; (require 'jl-encrypt)
             ;; (when (not (and (file-exists-p "~/Maildir/inventati")
             ;;                 (file-exists-p "~/Maildir/apc")))
             ;;   (call-process-shell-command
             ;;    (format
             ;;     "export ENCFS6_CONFIG=~/sb/encfs_keys/maildir/.encfs6.xml; echo '%s' | encfs --stdinpass ~/.maildir ~/Maildir"
             ;;     (password-store-get "mail/encfs-maildir"))))
             ;; (require 'mu4e-autoloads)
             (unless (get-buffer "*mu4e-headers*")
               (mu4e))
             (when persp-mode
               (persp-switch "mail"))
             (switch-to-buffer "*mu4e-headers*")
             ;; (delete-other-windows)
             ;; (csb/mode-line-off)
             ;; Update each time emacs is idle for 5 min.
             ;; (setq csb/mu4e-timer-sync-with-server
             ;;       (run-with-idle-timer 300 t 'csb/mu4e-sync-with-server))
             ;; Update every 3 min (same as systemd unit)
             ;; (setq csb/mu4e-timer-sync-with-index
             ;;       (run-with-timer 180 180 'csb/mu4e-sync-with-index))
             ;; (mu4e-context-switch nil nil)
             )
            (t (message "NO GPG KEY FOUND, SB OPEN??"))))

    :config (csb/org-require 'csb-mu4e)

    :bind
    (:map launcher-map
          ("4" . csb/mu4e)))
#+end_src

_References:_

 - [[elfeed:irreal.org#https://irreal.org/blog/?p=9411][Setting Up Mu4e]]

* Elfeed

Create a defun to launch =Elfeed= and autoload it.

#+begin_src emacs-lisp
  (use-package elfeed

  ;;; Commands

    :commands (elfeed)

  ;;; Init

    :init

    (defun csb/elfeed ()
      "Launch elfeed in its persp and create related timers."
      (interactive)
      ;; if no elfeed buffer aroung, launch it
      (unless (get-buffer "*elfeed-search*")
        (elfeed-org)
        (elfeed)
        (when (csb/internet-up-p)
          ;; Update for feeds each time emacs is idle for 10 min
          (setq csb/elfeed-timer-update
                (run-with-idle-timer 600 t 'elfeed-update))
          ;; Force refresh view of the feed listing
          (setq csb/elfeed-timer-update--force
                (run-with-idle-timer 700 t 'elfeed-search-update--force))
          ;; Save and minimize the database storage size on the filesystem
          (setq csb/elfeed-timer-db-compact
                (run-with-idle-timer 1200 t 'elfeed-db-compact))))
      (when persp-mode
        (persp-switch "elfeed"))
      (switch-to-buffer (get-buffer "*elfeed-search*"))
      ;; Force refresh view of the feed listing.
      (elfeed-search-update--force))

  ;;; Config

    :config

  ;;;; Variables

    (setq elfeed-search-filter "@6-months-ago -boulot +unread -comments"
          elfeed-use-curl t
          elfeed-curl-max-connections 30
          elfeed-db-directory (format "%selfeed" user-emacs-directory)
          elfeed-search-title-max-width
          (cond ((= (csb/identify-monitor) 1) 80)
                ((= (csb/identify-monitor) 2) 80)
                ((= (csb/identify-monitor) 3) 80)
                ((= (csb/identify-monitor) 4) 80)
                ((= (csb/identify-monitor) 5) 90)
                ((= (csb/identify-monitor) 6) 88)
                ((= (csb/identify-monitor) 7) 80)
                ((= (csb/identify-monitor) 8) 80)
                ((= (csb/identify-monitor) 9) 80)
                (t 80))
          elfeed-search-title-min-width 16
          elfeed-sort-order 'descending
          ;; Space reserved for displaying the feed and tag information.
          elfeed-search-trailing-width
          (cond ((= (csb/identify-monitor) 1) 30)
                ((= (csb/identify-monitor) 2) 30)
                ((= (csb/identify-monitor) 3) 30)
                ((= (csb/identify-monitor) 4) 30)
                ((= (csb/identify-monitor) 5) 30)
                ((= (csb/identify-monitor) 6) 30)
                ((= (csb/identify-monitor) 7) 30)
                ((= (csb/identify-monitor) 8) 30)
                ((= (csb/identify-monitor) 9) 30)
                (t 30))
          elfeed-curl-timeout 30
          elfeed-show-truncate-long-urls t)

  ;;;; Custom defuns

    (defun csb/elfeed-stop ()
      "Stops elfeed properly."
      ;; (when (fboundp 'elfeed-db-compact)
      ;;   (elfeed-db-compact))
      ;; (when (fboundp 'elfeed-db-save)
      ;;   (elfeed-db-save))
      (when (boundp 'csb/elfeed-timer-update--force)
        (cancel-timer csb/elfeed-timer-update--force))
      (when (boundp 'csb/elfeed-timer-update)
        (cancel-timer csb/elfeed-timer-update))
      (when (boundp 'csb/elfeed-timer-db-compact)
        (cancel-timer csb/elfeed-timer-db-compact)))

    (defun csb/elfeed-search-live-filter-space ()
      "Insert space before running `elfeed-search-live-filter'."
      (interactive)
      (let ((elfeed-search-filter (concat elfeed-search-filter " ")))
        (elfeed-search-live-filter)))

    (defun csb/elfeed-handle-tags(arg)
      "Add/remove tags in elfeed search buffer.
    Provides a list of existing tags and adds it to current filter.
    With prefix `ARG' removes tags from existing list.
    With a double prefix removes tags from existing list."
      (interactive "P")
      (unless (featurep 'csb-miscellaneous)
        (csb/org-require 'csb-miscellaneous))
      (let ((current-filter (split-string elfeed-search-filter " ")))
        (setq elfeed-search-filter
              (cond
               ((equal arg '(16))
                (mapconcat 'identity
                           (csb/list-add current-filter
                                         (cl-set-difference
                                          (mapcar (lambda(arg)
                                                    (format "-%s" arg))
                                                  (elfeed-db-get-all-tags))
                                          current-filter :test 'string=)) " "))
               ((equal arg '(4))
                ;; remove tags from filter
                (csb/list-tostring
                 (csb/list-remove
                  (csb/list-tosymbol current-filter))))
               (t
                ;; add tags from filter
                (mapconcat 'identity
                           (csb/list-add current-filter
                                         (cl-set-difference
                                          (mapcar (lambda(arg)
                                                    (format "+%s" arg))
                                                  (elfeed-db-get-all-tags))
                                          current-filter :test 'string=)) " ")))))
      (elfeed-search-update :force)
      (back-to-indentation)
      (re-search-forward " "))

  ;;; Bind

    :bind
    (

  ;;;; Launcher map

     :map launcher-map
     ("e" . csb/elfeed)

  ;;;; Show map

     :map elfeed-show-mode-map
     ;; General
     ("y" . elfeed-show-yank)
     ("g" . elfeed-show-refresh)
     ;; navigation / scrolling
     ("f" . elfeed-show-next)
     ("b" . elfeed-show-prev)
     ("J" . elfeed-show-next)
     ("K" . elfeed-show-prev)
     ;; links
     ("tab" . shr-next-link)
     ("<backtab>" . shr-previous-link)
     ("tab" . shr-browse-url)
     ;; tagging
     ("+" . elfeed-show-tag)
     ("-" . elfeed-show-untag)
     ;; browsing
     ("O" . elfeed-show-visit-other-window)
     ("o" . elfeed-show-visit)
     ;; quit
     ("h" . (lambda()(interactive)
              (elfeed-kill-buffer)
              (switch-to-buffer "*elfeed-search*")))
     ;; remove defaults
     ("n" . nil)
     ("p" . nil)

  ;;;; Search map

     :map elfeed-search-mode-map
     ;; General
     ("j" . next-line)
     ("k" . previous-line)

     ("l" . elfeed-search-show-entry)
     ("<RET>" . elfeed-search-show-entry)

     ("+" . elfeed-search-tag-all)
     ("-" . elfeed-search-untag-all)

     ("r" . (lambda ()
              (interactive)
              (elfeed-search-untag-all-unread)
              (back-to-indentation)
              (re-search-forward " ")))
     ("u" . (lambda ()
              (interactive)
              (elfeed-search-tag-all-unread)
              (back-to-indentation)
              (re-search-forward " ")))

     ;; Add / remove tag emacs
     ("e" . (lambda ()
              (interactive)
              (elfeed-expose #'elfeed-search-tag-all 'emacs)))
     ("E" . (lambda ()
              (interactive)
              (elfeed-expose #'elfeed-search-untag-all 'emacs)))

     ;; Filtering by manipulating =elfeed-search-filter=
     ;; - _Insert space before live filter_
     ;; - http://xenodium.com/#quickly-swapping-elfeed-filters

     ("f" . csb/elfeed-handle-tags)
     ("i" . csb/elfeed-search-live-filter-space)

     ;; Updating

     ("$" . (lambda()
              (interactive)
              (when (csb/internet-up-p)
                (elfeed-update))))

     ;; Sync with current view with db

     ("S" . elfeed-search-update--force)

     ("Q" . (lambda()
              (interactive)
              (csb/elfeed-stop)
              (kill-this-buffer)
              (when (string= (and (daemonp) (daemonp)) "elfeed")
                (save-buffers-kill-terminal)))))

  ;;; Hooks

    :hook (

  ;;;; Show mode

           (elfeed-show-mode . (lambda ()
                                 ;; (setq-local show-trailing-whitespace nil)
                                 ;; (setq-local fill-column 120)
                                 (smartscan-mode -1)
                                 (modal-mode 1)
                                 (hide-mode-line-mode t)
                                 (setq buffer-face-mode-face
                                       `(:family "Meslo LG L DZ"))
                                 (buffer-face-mode t)
                                 (text-scale-increase 1.05)
                                 ;; (text-scale-set 1.5)
                                 ;; (text-scale-increase
                                 ;;  (cond ((= (csb/identify-monitor) 1) 0.5) ; laptop
                                 ;;        ((= (csb/identify-monitor) 2) 1) ; home monitor
                                 ;;        ((= (csb/identify-monitor) 3) 1) ; apc two monitors
                                 ;;        ((= (csb/identify-monitor) 4) 1) ; apc, one monitor
                                 ;;        (t 1)))
                                 ;; (text-scale-set 1)
                                 ;; (setq-local mode-line-format nil)
                                 ;; (mixed-pitch-mode 1)
                                 ;; (setq buffer-face-mode-face '(:family "symbola" :height 140))
                                 ;; (buffer-face-set 'variable-pitch)
                                 ;; (setq buffer-face-mode-face '(:family "Symbola" :height 1.0 :width semi-condensed))
                                 ;; Edit elfeed config mile
                                 ;; (local-set-key (kbd "<f3>")
                                 ;;             #'(lambda()(interactive)(find-config-file "csb-elfeed.page")))
                                 ;; (local-set-key (kbd "<f4>")
                                 ;;             #'(lambda()(interactive)(find-config-file-other-window "csb-elfeed.page")))
                                 ))
  ;;;; Search mode

           (elfeed-search-mode . (lambda ()
                                   ;; (setq-local after-focus-change-function nil)
                                   ;; (setq-local show-trailing-whitespace nil)
                                   ;; (setq-local fill-column 120)
                                   ;; (setq-local beacon-blink-when-point-moves-horizontally 1)
                                   ;; (setq-local beacon-blink-when-point-moves-vertically 1)
                                   (smartscan-mode -1)
                                   ;; (hide-mode-line-mode t)
                                   (modal-mode 1)
                                   ;; (setq-local mode-line-format nil)
                                   (setq buffer-face-mode-face
                                         `(:family "Meslo LG L DZ"))
                                   (buffer-face-mode t)
                                   ;; (text-scale-set 1.1)
                                   ;; Edit elfeed config mile
                                   ;; (local-set-key (kbd "<f3>")
                                   ;;             #'(lambda()(interactive)(find-config-file "csb-elfeed.page")))
                                   ;; (local-set-key (kbd "<f4>")
                                   ;;             #'(lambda()(interactive)(find-config-file-other-window
                                   ;;                                 "csb-elfeed.page")))
                                   ))))
#+end_src

* Telega

[[telega:-1001166929514?open_content#275][Hacer]]

#+begin_src emacs-lisp
  (use-package telega

    :ensure t

    :init

    (defun csb/telega ()
      "Launch telega using a dedicated tab."
      (interactive)
      (cond ((csb/internet-up-p)
             (when persp-mode
               (persp-switch "telega"))
             (unless (get-buffer "*Telega Root*")
               (telega nil)
               (telega-view-topics))
             (switch-to-buffer (get-buffer "*Telega Root*")))
            (t
             (message "NO NETWORK ??"))))

    (defun csb/telega-kill()
      (interactive)
      (telega-kill nil)
      (when (string= (persp-name (persp-curr)) "telega")
        (persp-kill "telega")))

    :commands (telega)

    :bind

    (:map telega-chat-mode-map
          (("C-c C-c" . telega-chatbuf-newline-or-input-send)
           ("C-m" . telega-chatbuf-newline-or-input-send)
           ("C-c C-e" . emoji-cheat-sheet-plus-insert)
           ("C-j" . electric-newline-and-maybe-indent)
           ("M-k" . (lambda ()
                      (interactive)
                      (if (string= (persp-name (persp-curr)) "telega")
                          (bury-buffer)
                        (persp-remove-buffer (current-buffer))))))
          :map telega-root-mode-map
          (("l" . push-button)
           ("Q" . csb/telega-kill)
           ("q" . (lambda ()
                    (interactive)
                    (if (string= (persp-name (persp-curr)) "telega")
                        (bury-buffer)
                      (persp-remove-buffer (current-buffer))))))
          :map launcher-map
          ("t" . csb/telega))

    :config

    ;; Contrib packages

    (require 'telega-dired-dwim)
    (require 'ol-telega)
    (require 'telega-alert)
    ;; (require 'telega-mnz)

    (defun csb/telega-open-file ()
      "Open FILE.org from chat.
  May get ID with i."
      (interactive)
      (telega-msg-get (telega-chat-get -1001166929514) 288358400
        (lambda (msg &optional _ignored)
          (telega-msg-open-document msg))))

    ;; (advice-add 'telega-switch-important-chat :around #'csb/telega-advice)
    (define-key global-map (kbd "C-x j") telega-prefix-map)

    (defun csb/telega-switch-important-chat ()
      "Launch using a dedicated tab."
      (interactive)
      (when (telega-filter-chats
             telega--ordered-chats
             '(or mention (and unread unmuted)))
        ;; (csb/tab-get-to-or-create "Telegram")
        (call-interactively 'telega-switch-important-chat)))

    (define-key telega-prefix-map (kbd "i") #'csb/telega-switch-important-chat)
    (define-key telega-prefix-map (kbd "t") #'csb/telega)

    (setq telega-completing-read-function 'helm--completing-read-default
          telega-root-fill-column 120
          ;; telega-use-tracking-for '(or unmuted mention)
          telega-use-tracking-for nil
          telega-emoji-font-family "Noto Color Emoji"
          telega-use-images t
          ;; telega-emoji-use-images t
          ;; telega-online-status-function 'telega-focus-state
          telega-chat-fill-column telega-root-fill-column
          telega-webpage-fill-column telega-root-fill-column
          telega-emoji-use-images t
          telega-chat-input-markups '(nil "org"))

    (telega-notifications-mode t)
    (telega-alert-mode t)

    :hook
    ((telega-open-file . (lambda ()
                           (telega-edit-file-mode t)))
     (telega-load . (lambda ()
                      (telega-mode-line-mode t)
                      (telega-appindicator-mode t)
                      (telega-autoplay-mode t)
                      ;; (global-telega-mnz-mode t)
                      ))
     (telega-chat-mode . (lambda ()
                           (emoji-cheat-sheet-plus-display-mode t)
                           (company-mode -1)
                           (setq buffer-face-mode-face
                                 `(:family "Meslo LG L DZ"))
                           (buffer-face-mode t)))
     (telega-root-mode . (lambda ()
                           (emoji-cheat-sheet-plus-display-mode t)
                           (setq buffer-face-mode-face
                                 `(:family "Meslo LG L DZ"))
                           (buffer-face-mode t)))))
#+end_src

* Paradox

[[https://github.com/Malabarba/paradox][Project]] for modernizing Emacs' Package Menu. With package ratings,
usage statistics, customizability, and more.

Use =h= to get help.

#+begin_src emacs-lisp
  (use-package paradox
    :ensure t
    :init
    (defun csb/paradox ()
      (interactive)
      (cond ((csb/internet-up-p)
             (unless (get-buffer "*Packages*")
               (paradox-enable)
               (csb/org-require 'csb-repositories t)
               ;; (require 'csb-convenience) ; provides tab-bar defuns
               ;; (csb/tab-get-to-or-create "Packages")
               (paradox-list-packages nil)
               ;; (list-packages no-fetch)
               )
             (when persp-mode
               (persp-switch "packages"))
             (switch-to-buffer "*Packages*"))
            (t
             (message "NO NETWORK ??"))))
    :bind
    (:map launcher-map
          ("p" . csb/paradox))
    :commands (paradox)
    :config
    (setq paradox-execute-asynchronously t
          paradox-column-width-version 15
          paradox-column-width-package 30
          paradox-column-width-download 7
          paradox-column-width-status 13
          paradox-automatically-star nil
          paradox-github-token t))
#+end_src

Two interesting functions are

#+begin_src emacs-lisp :tangle no
  (paradox-require)
  (paradox-upgrade-packages)
#+end_src

* Proced

Generate a listing of UNIX system processes. See [[help:proced-mode][proced-mode help]] for details.

#+begin_src emacs-lisp
  (use-package proced

    :init
    (defun csb/proced ()
      (interactive)
      (require 'csb-convenience) ; provides tab-bar defuns
      (csb/tab-get-to-or-create "Proced")
      (if (not (get-buffer "*Proced*"))
          (proced))
      (switch-to-buffer (get-buffer "*Proced*")))

    :commands (proced)

    :bind
    (:map proced-mode-map
          (("i" . proced-narrow))
          :map launcher-map
          ("P" . csb/proced))

    :hook
    (proced-mode . (lambda ()
                     (proced-toggle-auto-update t)))

    :config

    (setq proced-auto-update-interval 2)

    ;; [[https://github.com/travisjeffery/proced-narrow][Proced narrow]]
    (use-package proced-narrow
      :ensure t
      :after proced
      :bind (:map proced-mode-map
                  ("a" . proced-toggle-auto-update)
                  ("i" . (lambda ()
                           (interactive)
                           (proced-toggle-auto-update -1)
                           (proced-narrow))))))
#+end_src

_References_

 - [[http://www.masteringemacs.org/article/displaying-interacting-processes-proced][Displaying and Interacting with processes using Proced]]
 - [[http://emacsredux.com/blog/2013/05/02/manage-processes-with-proced/][Manage Processes With Proced]]

* Readability
:PROPERTIES:
:header-args:    :tangle no
:END:

#+begin_src emacs-lisp
  ;; (eval-after-load 'readability
  ;;   '(progn
  ;;      (define-key readability-map-common (kbd "n") nil)
  ;;      (define-key readability-map-common (kbd "j") nil)
  ;;      (define-key readability-map-common (kbd "p") nil)
  ;;      (define-key readability-map-common (kbd "k") nil)
  ;;      (define-key readability-map-common (kbd "f") nil)
  ;;      (define-key readability-map-common (kbd "l") nil)
  ;;      (define-key readability-map-common (kbd "b") nil)
  ;;      (define-key readability-map-common (kbd "h") nil)))
  (defun readability--open-article ($article-id)
    (w3m-browse-url (message (concat readability-url-base (format "/articles/%s" $article-id)))))
  (define-key launcher-map "R" 'readability-get-reading-list)
  ;; (setq readability-parameters
  ;;       '(("archive"  . nil)  ;; "0", "1"
  ;;         ("favorite" . nil)  ;; "0", "1"
  ;;         ("order"    . nil)  ;; "-date_added", "date_added", "-date_updated", "date_updated"
  ;;         ("page"     . nil)  ;; "1" ~
  ;;         ("per_page" . "50") ;; "1" ~ "50"
  ;;         ("domain"   . nil)  ;; string
  ;;         ("tags"     . "myhdl,tutorial" )  ;; string
  ;;         ))
#+end_src

* Reddit

See that https://github.com/ahungry/md4rd

#+begin_src emacs-lisp :tangle no
  (defun my-reddit (reddit)
    "Opens the REDDIT in eww-new-session"
    (interactive (list
                  (read-string "Enter the reddit (default: emacs): " nil nil "emacs" nil)))
    (persp-switch "reddit")
    (when (not (get-buffer (concat "reddit - " reddit)))
      (switch-to-buffer (get-buffer-create "*eww*"))
      (eww-browse-url (format "http://m.reddit.com/r/%s" reddit) t)
      (sit-for 2)
      (rename-buffer (concat "reddit - " reddit))
      (csb/mode-line-off)
      (local-set-key "Q" (lambda()(interactive)(kill-this-buffer)(persp-kill "reddit"))))
    (persp-set-buffer (concat "reddit - " reddit))
    (switch-to-buffer (concat "reddit - " reddit)))

  (define-key launcher-map "wR" #'my-reddit)
#+end_src

#+begin_src emacs-lisp :tangle no
  (stante-after md4rd
                (add-hook 'md4rd-mode-hook (lambda () (setq-local show-trailing-whitespace nil)))
                ;; (define-key md4rd-mode-map (kbd "SPC") #'widget-forward)
                ;; (define-key md4rd-mode-map (kbd "S-SPC") #'widget-backward)
                ;; (define-key md4rd-mode-map (kbd "TAB") (lambda ()(interactive)
                ;;                                          (beginning-of-line)
                ;;                                          (md4rd-widget-toggle-line)))
                (define-key md4rd-mode-map (kbd "l") (lambda ()(interactive)
                                                       (beginning-of-line)(tree-mode-expand-level 0)))
                (define-key md4rd-mode-map (kbd "h") (lambda ()(interactive)
                                                       (save-excursion
                                                         (goto-char (point-min))
                                                         (tree-mode-expand-level
                                                          1))))
                (define-key md4rd-mode-map (kbd "z") (lambda ()(interactive)
                                                       (when (button-at (point))
                                                         (message (symbol-name (button-type (button-at (point))))))
                                                       ))
                (define-key md4rd-mode-map (kbd "j") #'next-line)
                (define-key md4rd-mode-map (kbd "k") #'previous-line)
                (define-key md4rd-mode-map (kbd "n") #'next-line)
                (define-key md4rd-mode-map (kbd "p") #'previous-line)
                )
  (setq md4rd--oauth-refresh-token "2qAdvRyZkCa6RM6mEKOzmogdtZE")
  (setq md4rd--oauth-access-token "2qAdvRyZkCa6RM6mEKOzmogdtZE")
  (setq md4rd-subs-active '(emacs archlinux linux julia orgmode awesomewm fpga julialang qutebrowser))
#+end_src

* Diaspora

#+begin_src emacs-lisp :tangle no
  (defun my-diaspora ()
    (interactive)
    (if (csb/sb-check-open)
        (progn
          (add-to-list 'load-path (concat user-emacs-directory "libraries/diaspora.el"))
          (add-to-list 'load-path (concat user-emacs-directory "libraries/diaspora.el/libraries"))
          (require 'diaspora)
          (setq diaspora-show-images-by-default t)
          (setq diaspora-pod "diaspora-fr.org")
          (setq diaspora-username "csantosb")
          (if (eq diaspora-password nil)
              (setq diaspora-password (eval-expression (car (split-string (shell-command-to-string "pass www/diaspora") "\n")))))
          (persp-switch "diaspora")
          (if (not (get-buffer "D*"))
              (diaspora)))
      (message "NO GPG KEY FOUND, SB OPEN ?")))

  ;; (define-key launcher-map "d" #'my-diaspora)
#+end_src

* Lobsters

;; TODO: Fix this
;; https://github.com/kisom/lobsters.el/blob/master/lobste.rs.el
;; (autoload 'lobste.rs "/home/csantos/Dropbox/.emacs.d/libraries/lobste.rs.el" "View the lobste.rs home page." t nil)

* Stack Exchange
:PROPERTIES:
:header-args:    :tangle no
:END:

Launcher

#+begin_src emacs-lisp
  (defun csb-sx ()
    (interactive)
    (require 'sx-load)
    (persp-switch "sx")
    (sx-tab-all-questions nil)
    ;; (if (not (get-buffer "*question-list: All-Questions*"))
    ;;     (let ((csb-sx-tab (funcall (if ido-mode #'ido-completing-read #'completing-read)
    ;;                                "Switch to tab: " sx-tab--list
    ;;                                (lambda (tab) (not (equal tab sx-question-list--current-tab)))
    ;;                                t)))
    ;;       (call-interactively (intern (concat "sx-tab-" (downcase csb-sx-tab))))))
    )
  (define-key launcher-map "wx" #'csb-sx)
#+end_src

* Deft

[[http://jblevins.org/projects/deft/][Deft]] is an Emacs mode for quickly browsing, filtering, and editing directories of plain text [[http://emacs-fu.blogspot.com.es/2011/09/quick-note-taking-with-deft-and-org.html][notes]].

#+begin_src emacs-lisp
  (use-package deft

    :init

    (defun csb/deft (&optional arg)
      "Launch deft in default directory."
      (interactive "P")
      (cond ((equal arg '(4))
             (let ((deft-directory (file-name-directory buffer-file-name)))
               (deft)))
            (t
             (deft))))

    :commands (deft)

    :config
    (setq deft-directory "/home/csantos/Projects/perso/CsbWiki"
          deft-recursive nil
          deft-use-filter-string-for-filename t
          deft-default-extension "org"
          deft-use-filename-as-title t
          deft-strip-summary-regexp "\\(:PROPERTIES:\n\\(.+\n\\)+:END:\n\\|^#\\+title: *.*\\|^#\\+filetags: *.*\\)")

    ;; I declare here a custom version of the title parsing routine in order to manipulate the file
    ;; name to extract the title when deft-use-filename-as-title is set to t

    (defun deft-parse-title (file contents)
      "Parse the given FILE and CONTENTS and determine the title.
      If `deft-use-filename-as-title' is nil, the title is taken to
      be the first non-empty line of the FILE.  Else the base name of the FILE is
      used as title."
      (if deft-use-filename-as-title
          ;; (deft-base-filename file)
          ;; csb
          (let ((title (deft-base-filename file)))
            (deft-chomp (replace-regexp-in-string "^.*-" "" title)))
        ;; csb
        (let ((begin (string-match "^.+$" contents)))
          (if begin
              (funcall deft-parse-title-function
                       (substring contents begin (string-match "^\\s-?$" contents)))))))

    :bind
    (:map launcher-map
          ("d" . csb/deft)
          :map deft-mode-map
          ("C-j" . deft-complete)
          ("C-d" . deft-filer-decrement)))
#+end_src

#+begin_src emacs-lisp :tangle no
  (require 'el-patch)
  (use-package deft
    :bind
    ("C-c n d" . (lambda ()
                   (interactive)
                   (csb/tab-get-to-or-create "Deft")
                   (deft)))
    :config/el-patch
    (defun deft-parse-title (file contents)
      "Parse the given FILE and CONTENTS and determine the title.
  If `deft-use-filename-as-title' is nil, the title is taken to
  be the first non-empty line of the FILE. Else the base name of the FILE is
  coused as title."
      (el-patch-swap (if deft-use-filename-as-title
                         (deft-base-filename file)
                       (let ((begin (string-match "^.+$" contents)))
                         (if begin
                             (funcall deft-parse-title-function
                                      (substring contents begin (match-end 0))))))
                     (org-roam--get-title-or-slug file)))
    :config
    (csb/org-require 'csb-deft t))
#+end_src

* Calendar
:PROPERTIES:
:header-args:    :tangle no
:END:

Start the calendar.

#+begin_src emacs-lisp
  (defun csb/cfw-calendar (arg)
    "Launch cfw-calendar.
              With a prefix argument ARG, launch ."
    (interactive "P")
    (csb/org-require 'csb-calendar t)
    (let ((csb/runorgconfig-enable nil))
      (when (not (string= (persp-name (persp-curr)) "OrgAgenda"))
        ;; (set-frame-parameter nil 'fullscreen 'maximized)
        (persp-switch "OrgAgenda")
        (find-file (concat org-directory "agendas.org")))
      ;; ics only when online
      (when (remove-if (lambda (el)
                         (string-match-p "lo.*" (car el)))
                       (network-interface-list))
        (csb/cfw-update-ics))
      (if (not (get-buffer "*cfw-calendar*"))
          (if (equal arg '(4))
              ;;
              (cfw:open-calendar-buffer
               :contents-sources csb/cfw-agenda-list)
            ;; based upon cfw:open-org-calendar
            (save-excursion
              (let* ((cp (cfw:create-calendar-component-buffer
                          :view 'month
                          :contents-sources csb/cfw-agenda-list
                          :custom-map cfw:org-schedule-map
                          :sorter 'cfw:org-schedule-sorter)))
                (switch-to-buffer (cfw:cp-get-buffer cp))))))
      (persp-set-buffer "*cfw-calendar*")
      (switch-to-buffer "*cfw-calendar*")
      (csb/mode-line-off)
      (csb/calendar-fringes)
      (call-interactively 'cfw:refresh-calendar-buffer)))
#+end_src

Associate launcher to a key in the launcher map.

#+begin_src emacs-lisp :tangle no
  (define-key launcher-map "C" #'csb/cfw-calendar)
#+end_src

* Origami
:PROPERTIES:
:header-args:    :tangle no
:END:

#+begin_src emacs-lisp
  (global-origami-mode 1)
  (defhydra csb/hydra-origami (:color red)
    "
    _o_pen node    _n_ext fold       toggle _f_orward
    _c_lose node   _p_revious fold   toggle _a_ll
                                     _t_oggle node
    "
    ("o" origami-open-node)
    ("c" origami-close-node)
    ("n" origami-next-fold)
    ("t" origami-toggle-node)
    ("p" origami-previous-fold)
    ("f" origami-forward-toggle-node)
    ("a" origami-toggle-all-nodes))
#+end_src

origami-toggle-node

Associate launcher to a key in the launcher map.

#+begin_src emacs-lisp :tangle no
  (define-key launcher-map "o" #'csb/hydra-origami/body)
#+end_src

* Erc

[[id:7051a2a9-4b54-455b-a0ee-58b37f27428d][Erc]] is a powerful, modular, and extensible IRC client for Emacs.

#+begin_src emacs-lisp
  (use-package erc

  ;;; Commands

    :commands (erc)

  ;;; Init

    :init

    (defun csb/erc ()
      (interactive)
      (cond (;; Check network and secure box is open
             (and (csb/internet-up-p)
                  (csb/sb-check-open))
             (when persp-mode
               (persp-switch "erc"))
             ;; Start conexion to remote tls server
             (unless (and (get-buffer "Libera.Chat")
                          (get-buffer "#guix"))
               (let ((erc-nick (password-store-get-field "www/erc" "user"))
                     (erc-password (password-store-get "www/erc")))
                 (erc-tls :server "irc.eu.libera.chat"
                          :port 6697
                          :nick erc-nick
                          :password erc-password)
                 (sit-for 5)))
             ;; Start conexion to local Bitlbee server
             (unless (get-buffer "&bitlbee")
               (let ((erc-nick (password-store-get-field "www/bitlbee" "user"))
                     (erc-password (password-store-get "www/bitlbee")))
                 (erc :server "localhost"
                      :port 6667
                      :nick erc-nick
                      :password erc-password)
                 (sit-for 5)))
             ;; So that I may password identify to the server
             (switch-to-buffer "&bitlbee"))
            ;; When no network or no secure box open
            (t
             (if (not (csb/internet-up-p))
                 (message "NO NETWORK ??")
               (message "NO GPG KEY FOUND, SB OPEN ??")))))

    ;; once launched, setup windows
    ;; (persp-switch "erc")
    ;; do a 2x1 tile
    ;; (split-window-multiple-ways 2 2)
    ;; ;; add buffers to this perspective
    ;; (when (get-buffer "#emacs")
    ;;   ;; (persp-set-buffer "#emacs")
    ;;   (set-window-buffer-in-frame 0 0 (get-buffer "#emacs")))
    ;; (when (get-buffer "#archlinux")
    ;;   ;; (persp-set-buffer "#archlinux")
    ;;   (set-window-buffer-in-frame 1 0 (get-buffer "#archlinux")))
    ;; (when (get-buffer "#emacsfr")
    ;;   ;; (persp-set-buffer "#emacsfr")
    ;;   (set-window-buffer-in-frame 0 1 (get-buffer "#emacsfr")))
    ;; (when (get-buffer "#archlinux-fr")
    ;;   ;; (persp-set-buffer "#archlinux-fr")
    ;;   (set-window-buffer-in-frame 1 1 (get-buffer "#archlinux-fr")))
    ;; ;; (when (get-buffer "#orgmode")
    ;; ;;   (persp-set-buffer "#orgmode"))
    ;; (require 'window-numbering)
    ;; (select-window-2)
    ;; (shrink-window 9)
    ;; (select-window-4)
    ;; (shrink-window 9)
    ;; (window-configuration-to-register :r)

  ;;; Config

    :config

  ;;;; Packages

    (use-package erc-hl-nicks
      :after erc
      :config
      (add-to-list 'erc-modules 'hl-nicks))

    (use-package erc-image
      :after erc
      :config
      (setq erc-image-inline-rescale 300)
      (add-to-list 'erc-modules 'image))

    (require 'erc-goodies)

  ;;;; Defuns

    ;; (defun csb/erc-cmd-QUERY (nick)
    ;;      (interactive (list (completing-read "Nick: " channel-members)))
    ;;      (erc-cmd-QUERY nick))

    ;; ;; This causes ERC to connect to the Freenode network upon hitting
    ;; ;; C-c e f.  Replace MYNICK with your IRC nick.
    ;; (global-set-key "\C-cef" (lambda () (interactive)
    ;;                               (erc :server "irc.freenode.net" :p9kJ>IZ|q2Zn4}VA80COm      ;; erc-join-buffer 'window-noselect

    ;; This causes ERC to connect to the IRC server on your own machine (if
    ;; you have one) upon hitting C-c e b.  Replace MYNICK with your IRC
    ;; nick.  Often, people like to run bitlbee (http://bitlbee.org/) as an
    ;; AIM/Jabber/MSN to IRC gateway, so that they can use ERC to chat with
    ;; people on those networks.
    ;; (global-set-key "\C-ceb" (lambda () (interactive)
    ;;                               (erc :server "localhost" :port "6667"
    ;;                                 :nick "MYNICK")))

  ;;;; Commands

    ;; This is an example of how to make a new command.  Type "/uptime" to use it.
    ;;     (defun erc-cmd-UPTIME (&rest ignore)
    ;; "Display the uptime of the system, as well as some load-related
    ;;    stuff, to the current ERC buffer."
    ;; (let ((uname-output
    ;;        (replace-regexp-in-string
    ;;         ", load average: " "] {Load average} ["
    ;;         ;; Collapse spaces, remove
    ;;         (replace-regexp-in-string
    ;;          " +" " "
    ;;          ;; Remove beginning and trailing whitespace
    ;;          (replace-regexp-in-string
    ;;           "^ +\\|[ \n]+$" ""
    ;;           (shell-command-to-string "uptime"))))))
    ;;   (erc-send-message
    ;;    (concat "{Uptime} [" uname-output "]"))))

    ;; (defun erc-check-connected-and-reconnect () nil)
    ;; (defun erc-check-connected-and-reconnect ()
    ;;      (when (and (get-buffer "#emacsfr")
    ;;                 (equal (erc-server-process-alive "#emacsfr") nil))
    ;;        (progn
    ;;       (persp-switch "erc")
    ;;       (switch-to-buffer "#emacsfr")
    ;;       ;; we need to be in ERC buffer to call this function
    ;;       (erc-server-reconnect))))

    ;; (erc-server-reconnect-attempts 5)
    ;; (erc-server-reconnect-timeout 3)

    ;; (setq erc-check-connected-and-reconnect-timer
    ;;       (run-with-idle-timer 60 t 'erc-check-connected-and-reconnect))

  ;;;; Variables

    (setq
     erc-auto-query 'bury
     erc-full-name "Cayetano Santos"
     ;; Non-nil means that ERC will attempt to reestablish broken connections.

     ;; Reconnection will happen automatically for any unexpected disconnection.
     erc-server-auto-reconnect t
     erc-server-reconnect-timeout 10
     ;; erc-join-buffer 'window-noselect

     erc-server-coding-system '(utf-8 . utf-8) ; utf-8 always and forever

     ;; Join the given channels whenever connecting to Freenode.
     erc-autojoin-channels-alist '(("irc.eu.libera.chat" "#guix" "#emacs" "#archlinux" "#emacsfr" "#systemcrafters"))

     erc-autojoin-timing 'ident

     ;; Interpret mIRC-style color commands in IRC chats
     erc-interpret-mirc-color t

     ;; Non-nil means rename buffers with network name, if available.
     erc-rename-buffers t

     ;; A global list of IRC message types to hide.
     erc-hide-list '("JOIN" "NICK" "PART" "QUIT" "MODE" "AWAY" "324" "329" "332" "333" "353"
                     "477")
     erc-lurker-hide-list '("JOIN" "PART" "QUIT")
     erc-lurker-threshold-time 43200
     ;; Kill buffers for channels after /part
     erc-kill-buffer-on-part t
     ;; Kill buffers for private queries after quitting the server
     erc-kill-queries-on-quit t
     ;; Kill buffers for server messages after quitting the server
     erc-kill-server-buffer-on-quit t
     ;; Open query buffers in the current window
     erc-query-display 'window)

  ;;;; Modules

  ;;;;; All

    (setq erc-modules '(spelling pcomplete netsplit button match completion
                                 readonly networks ring autojoin noncommands
                                 irccontrols move-to-prompt stamp menu))

  ;;;;; Notify

    ;; Module that allows you to keep track of the online status of certain people. It
    ;; defines a new command, =/;; once launched, setup windows
    ;; (persp-switch "erc")
    ;; do a 2x1 tile
    ;; (split-window-multiple-ways 2 2)
    ;; ;; add buffers to this perspective
    ;; (when (get-buffer "#emacs")
    ;;   ;; (persp-set-buffer "#emacs")
    ;;   (set-window-buffer-in-frame 0 0 (get-buffer "#emacs")))
    ;; (when (get-buffer "#archlinux")
    ;;   ;; (persp-set-buffer "#archlinux")
    ;;   (set-window-buffer-in-frame 1 0 (get-buffer "#archlinux")))
    ;; (when (get-buffer "#emacsfr")
    ;;   ;; (persp-set-buffer "#emacsfr")
    ;;   (set-window-buffer-in-frame 0 1 (get-buffer "#emacsfr")))
    ;; (when (get-buffer "#archlinux-fr")
    ;;   ;; (persp-set-buffer "#archlinux-fr")
    ;;   (set-window-buffer-in-frame 1 1 (get-buffer "#archlinux-fr")))
    ;; ;; (when (get-buffer "#orgmode")
    ;; ;;   (persp-set-buffer "#orgmode"))
    ;; (require 'window-numbering)
    ;; (select-window-2)
    ;; (shrink-window 9)
    ;; (select-window-4)
    ;; (shrink-window 9)
    ;; (window-configuration-to-register :r)NOTIFY=. Change =erc-notify-list= or list current
    ;; notify-list members online. Without args, list the current list of notified
    ;; people online, with args, toggle notify status of people.

    (add-to-list 'erc-modules 'notify)

    ;; List of nicknames you want to be notified about online/offline status change.

    (setq erc-notify-list '("Selmaconforti" "anataelcabrera" "msettimo" "acer0_2000"))

    ;; Time interval (in seconds) for checking online status of notified people.

    (setq erc-notify-interval 60)

    ;; See [[https://www.emacswiki.org/emacs/ErcNotify][emacs wiki]] for details.

  ;;;;; Notifications

    ;; This implements notifications using `notifications-notify' on PRIVMSG received
    ;; and on public nickname mentions.

    (add-to-list 'erc-modules 'notifications)

    (setq erc-notifications-icon "/home/csantos/NextCloud/Pictures/icons/chat-icon.png")

    ;; (erc-notifications-notify "Nick" "Message") ; test appearance

  ;;;;; Fill

    (add-to-list 'erc-modules 'fill)

    (setq erc-fill-function 'erc-fill-static
          ;; Column around which all statically filled messages will be centered.
          erc-fill-static-center (cond ((= (csb/identify-monitor) 1) 30)
                                       ((= (csb/identify-monitor) 2) 20)
                                       ((= (csb/identify-monitor) 3) 30)
                                       ((= (csb/identify-monitor) 4) 30)
                                       ((= (csb/identify-monitor) 5) 25)
                                       ((= (csb/identify-monitor) 6) 25)
                                       (t 25))
          ;; The column at which a filled paragraph is broken.
          erc-fill-column (cond ((= (csb/identify-monitor) 1) 80)
                                ((= (csb/identify-monitor) 2) 120)
                                ((= (csb/identify-monitor) 3) 80)
                                ((= (csb/identify-monitor) 4) 80)
                                ((= (csb/identify-monitor) 5) 90)
                                ((= (csb/identify-monitor) 6) 120)
                                (t 110)))

  ;;;;; Autoaway

    ;; https://www.emacswiki.org/emacs/ErcAutoAway

    (add-to-list 'erc-modules 'autoaway)

    (setq erc-auto-set-away t
          erc-auto-discard-away t
          erc-autoaway-idle-seconds 1800
          erc-autoaway-idle-method 'user)

  ;;;;; Track

    ;; Exclude boring stuff from tracking

    (add-to-list 'erc-modules 'track)

    (setq
     erc-track-exclude nil ; '("#emacs")
     erc-track-visibility nil ; Only use the selected frame for visibility
     erc-track-shorten-start 8
     erc-track-exclude-server-buffer t
     erc-track-exclude-types '("JOIN" "NICK" "PART" "QUIT" "MODE" "AWAY" "324" "329" "332" "333" "353"
                               "477"))

  ;;;;; Scrollbottom

    ;; This mode causes the prompt to stay at the end of the window.
    (add-to-list 'erc-modules 'scrolltobottom)

  ;;;;; Smileys

    (add-to-list 'erc-modules 'smiley)

  ;;;;; Truncate

    ;; Truncate too long buffers

    (add-to-list 'erc-modules 'truncate)

  ;;;;; Move-to-prompt

    ;; This mode causes the point to be moved to the prompt when typing text.

    (add-to-list 'erc-modules 'move-to-prompt)

  ;;;;; Keep-place

    ;; Leave point above un-viewed text in other channels.

    (add-to-list 'erc-modules 'keep-place)

  ;;;;; Update

    (erc-update-modules)

  ;;;; Highligh notifications

    ;; (font-lock-add-keywords
    ;;  'erc-mode
    ;;  '((";;.*\\(bzg2\\|éducation\\|clojure\\|emacs\\|orgmode\\)"
    ;;     (1 bzg-todo-comment-face t))))

  ;;; Binds

    :bind (:map launcher-map
                ("E" . csb/erc)
                ;; ("B" . csb/bitlbee)
                :map erc-mode-map
                ("C-c C-c" . erc-send-current-line)
                ("C-m" . erc-send-current-line)
                ("C-j" . electric-newline-and-maybe-indent)
                ("C-<return>" . nil)
                ("<return>" . nil)
                ("M-k" . (lambda ()
                           (interactive)
                           (if (string= (persp-name (persp-curr)) "erc")
                               (bury-buffer)
                             (persp-remove-buffer (current-buffer))))))
    ;; ("C-c C-q" . csb/erc-cmd-QUERY)

  ;;; Hooks

    :hook ((erc-mode . (lambda ()
                         (emojify-mode 1)
                         ;; (erc-colorize-mode 1) ;; TODO: erc-colorize-faces
                         ;; (text-scale-increase (cond ((= (csb/identify-monitor) 1) 0)
                         ;;                            ((= (csb/identify-monitor) 2) 0.5)
                         ;;                            ((= (csb/identify-monitor) 3) 0)
                         ;;                            ((= (csb/identify-monitor) 4) 0)
                         ;;                            ((= (csb/identify-monitor) 5) 0)
                         ;;                            (t 0)))
                         ;; (hide-mode-line-mode t)
                         (smartscan-mode -1)
                         (hl-line-mode 1)
                         ;; (when (string-prefix-p "#" (buffer-name))
                         ;;   (read-only-mode 1))
                         (setq-local erc-prompt (lambda () (concat " " (buffer-name) ">")))
                         ;; (erc-scroll-to-bottom-enable)
                         (set (make-local-variable 'scroll-conservatively) 100)
                         (setq-local show-trailing-whitespace nil)))))

  ;; TODO: missing
  ;; (use-package erc-colorize
  ;;   :after erc
  ;;   :config
  ;;   ;; refer to zenburn-default-colors-alist
  ;;   (custom-set-faces
  ;;    '(erc-distinct-1-face ((t (:foreground "#7F9F7F")))) ; zenburn-green
  ;;    '(erc-distinct-6-face ((t (:foreground "#BFEBBF")))) ; zenburn-green+4
  ;;    '(erc-distinct-5-face ((t (:foreground "#CC9393")))) ; zenburn-red
  ;;    '(erc-distinct-4-face ((t (:foreground "#DFAF8F")))) ; zenburn-orange
  ;;    '(erc-distinct-7-face ((t (:foreground "#ECB3B3")))) ; zenburn-red+2"
  ;;    '(erc-distinct-3-face ((t (:foreground "#E0CF9F")))) ; zenburn-yellow-1
  ;;    '(erc-distinct-2-face ((t (:foreground "#8CD0D3")))) ; zenburn-blue
  ;;    )
  ;;   ;; (setq erc-colorize-faces
  ;;   ;;       '(
  ;;   ;;         ))
  ;;   )
#+end_src

** 0x0

https://melpa.org/#/0x0

** Webpaste

This mode allows to paste whole buffers or parts of buffers to pastebin-like services. It supports
more than one service and will failover if one service fails. More services can easily be added over
time and preferred services can easily be configured.

https://github.com/etu/webpaste.el

* SX
:PROPERTIES:
:header-args:    :tangle no
:END:

#+begin_src emacs-lisp
  (stante-after sx
    (csb/org-require 'csb-sx csb/compile-csb/org-require))
#+end_src

* Twittering
:PROPERTIES:
:header-args:    :tangle no
:END:

[[https://github.com/hayamiz/twittering-mode][@github]], [[http://www.emacswiki.org/emacs/TwitteringMode][@emacswiki]], [[http://twmode.sourceforge.net/][home page]]

** Helper

- Launcher

  #+begin_src emacs-lisp :tangle no
    (defun my-twit()
      "Launch twit."
      (interactive)
      (cond( (csb/sb-check-open)
             ;; change perspective
             (persp-switch "twitter")
             ;;
             (let* ((bitlbee-server (password-store-get "www/bitlbee" "server:"))
                    (bitlbee-buffer (concat "&bitlbee@" bitlbee-server))
                    (bitlbee-server-buffer (concat "*" bitlbee-server "*"))
                    (bitlbee-twitter-buffer (concat "#twitter_csantosb@" bitlbee-server)))
               ;; if already running, not launch it again
               (unless (and (get-buffer bitlbee-server-buffer) (get-buffer bitlbee-buffer))
                 (let* ((bitlbee-user (password-store-get "www/bitlbee" "user:"))
                        (bitlbee-password (password-store-get "www/bitlbee"))
                        (bitlbee-key (password-store-get "www/bitlbee" "key:"))
                        (bitlbee-port (password-store-get "www/bitlbee" "port:"))
                        ;; server config
                        ;; ref: https://stackoverflow.com/questions/1664202/emacs-lisp-evaluate-variable-in-alist
                        (rcirc-server-freenode `(,bitlbee-server
                                                 :nick ,bitlbee-user
                                                 :port ,bitlbee-port
                                                 :user-name ,bitlbee-user
                                                 :full-name ,bitlbee-user
                                                 :password ,bitlbee-password))
                        (rcirc-server-alist (list rcirc-server-freenode))
                        ;; credentials
                        (rcirc-authinfo-freenode (list bitlbee-server
                                                       'bitlbee
                                                       bitlbee-user
                                                       bitlbee-key))
                        (rcirc-authinfo (list rcirc-authinfo-freenode)))
                   (irc nil)
                   (sit-for 5)))
               ;; start twittering if necessary
               (unless (get-buffer ":home")
                 (twit)
                 (sit-for 2))
               ;; once launched, setup windows
               (persp-switch "twitter")
               ;; add buffers to this perspective
               (persp-set-buffer bitlbee-buffer)
               (persp-set-buffer bitlbee-server-buffer)
               (persp-set-buffer ":home")
               (when (get-buffer bitlbee-twitter-buffer)
                 (persp-set-buffer bitlbee-twitter-buffer)
                 (split-window-multiple-ways 1 2)
                 (set-window-buffer-in-frame 0 1 (get-buffer bitlbee-twitter-buffer))
                 (set-window-buffer-in-frame 0 0 (get-buffer ":home"))
                 (enlarge-window 20)
                 (goto-char (point-max))
                 (recenter 80))
               (select-window-2)
               (csb/mode-line-off)
               (select-window-1)
               (when (frame-parameter nil 'fullscreen)
                 (toggle-frame-fullscreen))))

           (t (message "NO GPG KEY FOUND, SB OPEN??"))))
  #+end_src

- Config

  #+begin_src emacs-lisp
    (with-eval-after-load 'twittering-mode

      (defun find-twittering-config-file-other ()
        "Edit the twittering-mode config file, in another window."
        (interactive)
        (find-file-other-window (concat org-config-path "csb-global-launchermap.page")))

      (defun find-twittering-config-file ()
        "Edit the twittering-mode config file."
        (interactive)
        (find-file (concat org-config-path "csb-global-launchermap.page"))))
  #+end_src

** Keys

- global

  #+begin_src emacs-lisp
    (define-key launcher-map "wt" #'my-twit)
  #+end_src

- Use

  #+begin_src emacs-lisp
    (with-eval-after-load 'twittering-mode
      (define-key twittering-mode-map (kbd "S-SPC") 'twittering-scroll-down))
  #+end_src

  SPC				twittering-scroll-up
  TAB				twittering-goto-next-thing
<backtab>		twittering-goto-previous-thing
C-v				twittering-scroll-up
<backspace>						twittering-scroll-down
M-v				twittering-scroll-down

f				twittering-switch-to-next-timeline
b				twittering-switch-to-previous-timeline
g				twittering-current-timeline
v				twittering-other-user-timeline
V				twittering-visit-timeline

a				twittering-toggle-activate-buffer
i				twittering-icon-mode

h				backward-char
l				forward-char
j				twittering-goto-next-status
k				twittering-goto-previous-status

n				twittering-goto-next-status-of-user
p				twittering-goto-previous-status-of-user

q				twittering-kill-buffer

C-c				Prefix Command
RET				twittering-enter
ESC				Prefix Command
$				end-of-line
0				beginning-of-line
G				twittering-goto-last-status
H				twittering-goto-first-status
L				twittering-other-user-list-interactive
R				twittering-toggle-or-retrieve-replied-statuses
U				twittering-push-uri-onto-kill-ring

^				beginning-of-line-text
d				twittering-direct-message

r				twittering-toggle-show-replied-statuses
t				twittering-toggle-proxy
u				twittering-update-status-interactive

<C-down-mouse-3>				mouse-set-point
<C-mouse-3>						twittering-push-tweet-onto-kill-ring


<mouse-1>		twittering-click

C-M-i			twittering-goto-previous-thing

C-c C-d			twittering-direct-messages-timeline
C-c C-e			twittering-erase-old-statuses
C-c C-f			twittering-friends-timeline
C-c C-l			twittering-update-lambda
C-c RET			twittering-retweet
C-c C-p			twittering-toggle-proxy
C-c C-q			twittering-search
C-c C-r			twittering-replies-timeline
C-c C-s			twittering-update-status-interactive
C-c C-t			twittering-set-current-hashtag
C-c C-u			twittering-user-timeline
C-c C-v			twittering-view-user-page
C-c C-w			twittering-delete-status
C-c D			twittering-delete-status
C-c g			Prefix Command

** Variables

#+begin_src emacs-lisp
  (with-eval-after-load 'twittering-mode
       (twittering-enable-unread-status-notifier)
       (setq twittering-private-info-file (concat user-emacs-directory ".twittering-mode.gpg"))
       (setq twittering-use-master-password t)
       (setq twittering-tinyurl-service 'bit.ly)
       (setq twittering-url-show-status nil)
       (setq twittering-edit-skeleton 'inherit-any)
       (twittering-icon-mode 1)
       ;; (setq twittering-initial-timeline-spec-string
       ;;       '("(:home+@)"
       ;;         "(:search/twittering mode/+:search/twmode/)"))
       (setq twittering-retweet-format '(nil _ " %u RT @%s: %t"))
       (setq twittering-status-format "%i %S %T ||%R%r") ;; %FILL[  ]{}  %RT{%s}
       ;; (setq twittering-status-format "%FOLD{%RT{%FACE[bold]{RT}}%i%s>>%r @%C{%Y-%m-%d %H:%M:%S} %@{}\n%FOLD[ ]{%T%RT{\nretweeted by %s @%C{%Y-%m-%d %H:%M:%S}}}}")
       (setq twittering-number-of-tweets-on-retrieval 20)
       (setq twittering-display-remaining t)
       (setq twittering-timer-interval 60)
       (setq twittering-use-icon-storage t)
       (setq twittering-convert-fix-size 48)
       (setq twittering-icon-storage-file (concat user-emacs-directory ".twittering-mode-icons.gz"))
       (setq twittering-reverse-mode t))
#+end_src

** Hooks

#+begin_src emacs-lisp
  (add-hook 'twittering-mode-hook (lambda ()
                                    (setq-local show-trailing-whitespace nil)
                                    (rename-modeline "twittering-mode" twittering-mode "twit")
                                    (local-set-key (kbd "C-c g I") 'find-twittering-config-file)
                                    (local-set-key (kbd "C-c g i") 'find-twittering-config-file-other)))
#+end_src

* Pinboard
:PROPERTIES:
:header-args:    :tangle no
:END:

** helper defuns

Launcher.

#+begin_src emacs-lisp :tangle no
  (defun my-pinboard ()
    "Opens pinboard in eww-new-session"
    (interactive)
    ;; (interactive (list
    ;;              (read-string "Enter the reddit (default: emacs): " nil nil "emacs" nil)))
    (persp-switch "pinboard")
    (if (not (get-buffer "eww - Pinboard: bookmarks for csantosb"))
        (progn
          (eww "https://pinboard.in/u:csantosb")
          ;; (sit-for 2)
          ;; (switch-to-buffer "*eww*")
          ;; (rename-buffer (concat "reddit-" reddit))
          (persp-set-buffer "eww - Pinboard: bookmarks for csantosb"))))

(define-key launcher-map "wp" #'my-pinboard)
#+end_src

API: add and get from / to pinboard

#+begin_src emacs-lisp
  (with-eval-after-load 'eww

       (defun eww-pinboard-add-current-buffer ()
         (interactive)
         (require 'pinboard-api)
         ;; (url &optional title description toread shared)
         (pinboard-add-interactively (plist-get eww-data :url) (plist-get eww-data :title) nil "yes" "yes"))

       (defun eww-pinboard-get (tag)
         "Only search tags (separate a maximum of 3 TAGS with a '+' eg., emacs+manual)"
         (interactive "sEnter tag ... : ")
         (require 'pinboard-api)
         (setenv "LC_ALL" "C")
         (setenv "LANG" "C")
         (eww-browse-url (shell-command-to-string (concat "sr pin -t=" tag " -u=csantosb")) t)))
#+end_src

** Variables

Cache file and completing with helm, not ido (default)

#+begin_src emacs-lisp
  ;;  (eval-after-load 'w3m
  ;;    '(progn
  ;;       (require 'pinboard-api)))
  ;; ("csantosb:2786ea2660c963b1b161")
    (with-eval-after-load 'pinboard-api
         (if (csb/sb-check-open)
             (setq pinboard-api-token (eval-expression (shell-command-to-string "pass www/pinboard-api-token")))
           (message "NO GPG KEY FOUND, SB OPEN??"))
         (setq pinboard-tags-cache-file-name "~/Dropbox/emacs.d/.pinboard-tags-cache")
         (setq pinboard-completing-read-function 'helm-comp-read)) ;; C-Ret to abort (see mode-line)
#+end_src

** Keys

Define a pinboard related map and add, get, go-home and go-unread are based on pinboard-api.

Global Tag is based on surfraw (not limited to any user)

#+begin_src emacs-lisp
  (with-eval-after-load 'eww

    (define-prefix-command 'pinboard-prefix)
    (define-key eww-mode-map (kbd "M-p") 'pinboard-prefix)

    (define-key pinboard-prefix (kbd "a") 'eww-pinboard-add-current-buffer)  ;; add
    (define-key pinboard-prefix (kbd "g") 'eww-pinboard-get)                 ;; get
    (define-key pinboard-prefix (kbd "h")                                    ;; go-home
      (lambda ()(interactive)
        (eww-browse-url "http://pinboard.in/u:csantosb")))
    (define-key pinboard-prefix (kbd "u")                                    ;; unread
      (lambda()(interactive)
        (eww-browse-url "http://pinboard.in/u:csantosb/unread")))
    (define-key pinboard-prefix (kbd "t")                                    ;; tag: query anyone's tags
      (lambda () (interactive)
        (let ((a-tag (read-from-minibuffer "tag?" " ")))
          (browse-url (shell-command-to-string (concat "sr pin " a-tag)))))))
#+end_src



* Trailer

#+begin_src emacs-lisp
  (provide 'csb-apps)

  (defvar csb/csb-apps 'loaded "module is loaded successfully")

  ;;; csb-apps.el ends here
#+end_src
